/*

	GlM[E[^

	switch.h

	XBb`̎荞

	Copyrights 2010,  Yoshi Hiroshi.

 */


#define SW_IN_RIGHT             (PINB & _BV(PINB4))
#define SW_IN_LEFT              (PINB & _BV(PINB3))

#define IS_RIGHT_PUSHED()       SW_IS_ON(swRight,SW_PUSH_FLAG)
#define IS_RIGHT_LONG()         SW_IS_ON(swRight,SW_LONG_FLAG)
#define IS_RIGHT_RELEASED()     SW_IS_ON(swRight,SW_RELEASE_FLAG)
#define CLR_RIGHT_PUSHED()      SW_OFF(swRight,SW_PUSH_FLAG)
#define CLR_RIGHT_LONG()        SW_OFF(swRight,SW_LONG_FLAG)
#define CLR_RIGHT_RELEASED()    SW_OFF(swRight,SW_RELEASE_FLAG)

#define IS_LEFT_PUSHED()        SW_IS_ON(swLeft,SW_PUSH_FLAG)
#define IS_LEFT_LONG()          SW_IS_ON(swLeft,SW_LONG_FLAG)
#define IS_LEFT_RELEASED()      SW_IS_ON(swLeft,SW_RELEASE_FLAG)
#define CLR_LEFT_PUSHED()       SW_OFF(swLeft,SW_PUSH_FLAG)
#define CLR_LEFT_LONG()         SW_OFF(swLeft,SW_LONG_FLAG)
#define CLR_LEFT_RELEASED()     SW_OFF(swLeft,SW_RELEASE_FLAG)


extern unsigned char swRight;
extern unsigned char swLeft;

#define IS_SW_PUSHED(sw)        SW_IS_ON(sw,SW_PUSH_FLAG)
#define IS_SW_LONG(sw)          SW_IS_ON(sw,SW_LONG_FLAG)
#define IS_SW_RELEASED(sw)      SW_IS_ON(sw,SW_RELEASE_FLAG)

#define SW_PUSH_FLAG            1
#define SW_LONG_FLAG            2
#define SW_RELEASE_FLAG         3
#define SW_PREV_FLAG            6
#define SW_CURR_FLAG            7
#define SW_ON(sw,pos)           (sw |= _BV(pos))
#define SW_OFF(sw,pos)          (sw &= ~_BV(pos))
#define SW_SET(sw,pos,val)      (sw = val ? (sw | _BV(pos)) : (sw & ~_BV(pos)))
#define SW_GET(sw,pos)          ((sw & _BV(pos)) != 0)
#define SW_IS_ON(sw,pos)        ((sw & _BV(pos)) != 0)
#define SW_IS_OFF(sw,pos)       ((sw & _BV(pos)) == 0)

void switchInit();
void checkSwitches();
